/**
 * Created by blr on 19/10/15.
 */
/** Initialize component when component is dragged to component list (onCreateComponent must be exist in each html component file) */
try{
    function onInitComponent(oComponent){

        //console.log("%c/components/"+ oComponent.getType() +"/initialization","color:purple");

        //Call common initialize component inside mainframe
        //$.loadSyncScript("./components/mainframe/init.js");
        //eval( QT.readFile("./components/mainframe/init.js") );
        onInitMainframeComponent(oComponent);

        //Set default values
        oComponent.addParamVal("name", _D("Seat")+" "+oComponent.UId);

        //Select default Gui gateway
        oComponent.setParamVal("gateway",application.getGatewaysByProtocol("gui")[0]);

        var aIcons = oComponent.getParamVal("icons");
        aIcons.push(blr.gfxResource.getIconByTypeName(0,"info"));

        oComponent.addParamVal("viewmodelist",[
            {id:0, label:"Classic"}
            //,{id:1, label:"Modal"}
            //,{id:2, label:"Only Text"}
            //,{id:3, label:"Hidden"}
        ]);

        //Ghost
        oComponent.addParamVal("ghost/virtual-feedback",true);
        oComponent.addParamVal("ghost/userdata","");

        //GUI
        oComponent.addParamVal("gui/label","text");

        //EVE
        oComponent.addParamVal("eve/uid","");


        // Components
        // BEGIN MUST BE ALWAYS EXIST
        oComponent.addParamVal("gui/components-list",[
            {label:"Dynamic List (id,label)",uid:"dynamic",type:"dynamic"},
            {label:"Seat ID",uid:"uid",type:"info"},
            {label:"Seat Name",uid:"name",type:"info"}
        ]);
        oComponent.addParamVal("gui/components", new Array() );
        // END MUST BE ALWAYS EXIST

        // Component Parameters
        oComponent.addParamVal("EVEUIStyle","onlyMap");
    }
}
catch(err){
    console.error(err);
}
