/** Update component component properties */
try{
    // Init component \see data in component html
    function onInitComponent(data){
        //console.log("[onInitComponent][" + data.source() + "][" + data + "]");
        return true;
    }
    // compones-mainframe.html callback
    function onGuiChangeGateway(sender,gateway,data) {
        //console.log("[onGuiChangeGateway][" + sender.source + "][" + gateway.getProtocol() + "][" + data + "]");
        //return updateProtocol(gateway.getProtocol(),data);
        return true;
    }
    /** On Update Component Function (Required)
     * Update component when some change has occured
     */
    function onUpdateComponent(data){

        var oComponent = data.node();
        //Check
        if(! (oComponent instanceof Component) ){
            throw "oComponent is not a Component instance";
            return false;
        }

        $("[eve-manager-id='UID']").text(oComponent.UId);
        $("[eve-manager-id='type']").text(oComponent.type);

        //Force set enable cache
        $Elem = $componentProperties.find("[eve-manager-id='cache']");
        $Elem.prop("checked",true);
        $Elem.prop("disabled",true);
        oComponent.setParamVal("cache",true);
        
        //Set icon
        $Elem = $componentProperties.find("[eve-manager-id='icons']");
        var aIcons = oComponent.getParamVal("icons");
        for(var i=0; i<aIcons.length; ++i){
            var oIcon = aIcons[i];
            var $wrapper = $("<div class='icon'></div>");
            var $canvas = $("<canvas></canvas>");
            var $status = $("<span></span>");
            var img = document.getElementById(oIcon.srcId);
            //var img = document.getElementById("./css/icons-set/images/icons-state_1-128x128.png");
            
            //Default image loading
            var imgHeight = parseInt(img.height,10);                        // Image height
            var imgWidth = parseInt(img.width,10);                          // Image width
            var stretchScale = 0.5;
            var drawHeight = imgHeight * stretchScale;
            var drawWidth = imgWidth * stretchScale; 
            var canvas = $canvas[0];
            var cont = canvas.getContext("2d");
            
            $canvas.attr("height",64);
            $canvas.attr("width",64);
            
            //Height - Width streched
      //      cont.drawImage(img,(oIcon.position.x * stretchScale),(oIcon.position.y * stretchScale),drawWidth,drawHeight);
            
        //    var imageData = cont.getImageData(0,0,64,64);
            
            //Color image
            if(oIcon.enableColors){
                //Color image
        /*        for(var j=0; j<imageData.data.length; j+=4){
                    imageData.data[j+0] = oIcon.color.R;
                    imageData.data[j+1] = oIcon.color.G;
                    imageData.data[j+2] = oIcon.color.B;
                    imageData.data[j+3] = imageData.data[j+3];
                }
          */  }
            
          //  cont.putImageData(imageData,0,0);
            
            $status.text(oIcon.status);
            
            $wrapper.append($canvas);
            $wrapper.append($status);
            $Elem.append($wrapper);
        }
    };
}
catch(err){
    console.error(err);
}
