/** Update component component properties */
try{
    // Init component \see data in component html
    function onInitComponent(data){
        //console.log("[onInitComponent][" + data.source() + "][" + data + "]");
        return true;
    }
    // compones-mainframe.html callback
    function onGuiChangeGateway(sender,gateway,data) {
        //console.log("[onGuiChangeGateway][" + sender.source + "][" + gateway.getProtocol() + "][" + data + "]");
        //return updateProtocol(gateway.getProtocol(),data);
        return true;
    }
    /** On Update Component Function (Required)
     * Update component when some change has occured
     */
    function onUpdateComponent(data){

        var oComponent = data.node();
    	//Check
        if(! (oComponent instanceof Component) ){
            throw "oComponent is not a Component instance";
            return false;
        }

        $("[eve-manager-id='UID']").text(oComponent.UId);
        $("[eve-manager-id='type']").text(oComponent.type);
        
    	//Set name
    	var $Elem = $componentProperties.find("[eve-manager-id='name']");
    	$Elem.val(oComponent.getParamVal("name"));
    	
    	//Set html name
    	$Elem = $("#"+ oComponent.id +" .components-text");
    	$Elem.text(oComponent.getParamVal("name"));
    	
    	//Build gateways
    	$Elem = $componentProperties.find("[eve-manager-id='gateway']");
    	$.publish("/view/gateways/refresh/dependencies");
    	
    	//Set gateways
    	$Elem = $componentProperties.find("[eve-manager-id='gateway'] option");
    	$componentProperties.find(".protocols").hide();												//Hide all protocols
    	for(var i = 0; i < $Elem.length; ++i){
    		var $currElem = $($Elem[i]);
    		var oNode = $currElem.data("eveManagerNode");
    		var strProtocol;
    		
    		//Find gateway
    		if(oNode === oComponent.getParamVal("gateway")){
    			
    			$currElem.prop("selected",true);													//Select gateway
    			if(oNode == undefined){ break; }													//If none gateway is selected break for cicle
    			
    			var oGateway = oNode.getData();														//Get node data (gateway)
    			
    			strProtocol = oGateway.getProtocol();												//Get protocol id
    			$componentProperties.find("[eve-manager-protocol='"+ strProtocol +"']").show();		//Show protocol view
    			break;
    		}
    	}
    	
    	//Set enable history
    	$Elem = $componentProperties.find("[eve-manager-id='history']");
    	$Elem.prop("checked",oComponent.getParamVal("history"));
    	
    	//Set enable savelastvalue
    	$Elem = $componentProperties.find("[eve-manager-id='savelastvalue']");
    	$Elem.prop("checked",oComponent.getParamVal("savelastvalue"));
    	
    	//Set enable cache
    	$Elem = $componentProperties.find("[eve-manager-id='cache']");
    	$Elem.prop("checked",oComponent.getParamVal("cache"));

        refreshTags(data);

    	//Set icon
        $Elem = $componentProperties.find("[eve-manager-id='icons']");
        var aIcons = oComponent.getParamVal("icons");
        $.publish("/view/components/"+ oComponent.id +"/refresh/parameter",[oComponent,"icons"]);

        //Set knx - working-time
        $Elem = $componentProperties.find("[eve-manager-id='working-time']");
        $Elem.val(oComponent.getParamVal("working-time"));

    	// KNX
    	
    	//Set KNX (long-operation) write address
        $Elem = $componentProperties.find("[eve-manager-id='knx/long-operation/write-address']");
        var aValue = oComponent.getParamVal("knx/long-operation/write-address").split("/");
        for(var i = 0; i<aValue.length; ++i){
            $Elem[i].value = aValue[i];
        }
        
        //Set KNX (long-operation) feedback address
        $Elem = $componentProperties.find("[eve-manager-id='knx/long-operation/feedback-address']");
        aValue = oComponent.getParamVal("knx/long-operation/feedback-address").split("/");
        for(var i = 0; i<aValue.length; ++i){
            $Elem[i].value = aValue[i];
        }
        
        //Set KNX (short-operation) write address
        $Elem = $componentProperties.find("[eve-manager-id='knx/short-operation/write-address']");
        var aValue = oComponent.getParamVal("knx/short-operation/write-address").split("/");
        for(var i = 0; i<aValue.length; ++i){
            $Elem[i].value = aValue[i];
        }
        
        //Set KNX (short-operation) feedback address
        $Elem = $componentProperties.find("[eve-manager-id='knx/short-operation/feedback-address']");
        aValue = oComponent.getParamVal("knx/short-operation/feedback-address").split("/");
        for(var i = 0; i<aValue.length; ++i){
            $Elem[i].value = aValue[i];
        }

        $Elem = $componentProperties.find("[eve-manager-id='knx/virtual-feedback']");
        $Elem.prop("checked",oComponent.getParamVal("knx/virtual-feedback"));

        $Elem = data.$properties().find("[eve-manager-id='knx/read-init']");
        $Elem.prop("checked", data.node().getParamVal("knx/read-init"));

        /** VIMAR By Me */
        
        //Set Vimar By Me
        {
                var json = blr.declarations.vimar.devices;
                $dropDown = $componentProperties.find("[eve-manager-id='vimar/device-pid']");
                var $none = $("<option value='none' dictionary='None'>"+ _D("None") +"</option>");
                $dropDown.append($none);
                
                //Parsing Vimar By Me Devices
                for(var i=0; i<json.length; ++i){
                    var $option = $("<option></option>");
                    
                    //Check if is for Combo
                    if(json[i].componentsType.indexOf("shutter") != -1){
                        $option.text(json[i].itemCodes.toString() +" - "+ _D(json[i].label));
                        $option.attr("title", _D(json[i].label));
                        $option.val(json[i].pid);
                        $option.data("VimarByMe",json[i]);
                        
                        //Append
                        $dropDown.append($option);
                    }
                }
                
                //Select currently FID
                var $selected = $dropDown.find("[value='"+ oComponent.getParamVal("vimar/device-pid") +"']");
                var oVimarDevice = $selected.data("VimarByMe");
                
                $selected.prop("selected",true);
                
                var $fid = $componentProperties.find("[eve-manager-id='vimar/device-fid']");
                var $none = $("<option value='none' dictionary='None'>"+ _D("None") +"</option>");
                
                //Empty combo selection
                $fid.empty();
                $fid.append($none);
                
                //Check if none device is selected
                if(oVimarDevice == undefined){
                    $none.prop("selected",true);
                    $fid.prop("disabled",true);
                }
                else{
                    //Fill option parameters
                    for(var i=0; i<oVimarDevice.fid.length; ++i){
                        oVimarDevice.fid[i];
                        var $option = $("<option></option>");
                        
                        $option.text(_D(oVimarDevice.fid[i].label));
                        $option.val(oVimarDevice.fid[i].value);
                        
                        $fid.append($option);
                    }
                    
                    $fid.removeProp("disabled");
                }
                
                //Select currently
                $fid.find("[value='"+ oComponent.getParamVal("vimar/device-fid") +"']").prop("selected",true);
            }
        
        //Set Vimar physical address
        $Elem = $componentProperties.find("[eve-manager-id='vimar/physical-address']");
        $Elem.val(oComponent.getParamVal("vimar/physical-address"));
        
        //Set Vimar group address
        $Elem = $componentProperties.find("[eve-manager-id='vimar/group-address']");
        $Elem.val(oComponent.getParamVal("vimar/group-address"));

        /** Ghost */

        //Set virtual feedback
        var $Elem = $componentProperties.find("[eve-manager-id='ghost/virtual-feedback']");
        $Elem.prop("checked", oComponent.getParamVal("ghost/virtual-feedback") );

        $Elem = $componentProperties.find("[eve-manager-id='ghost/userdata']");
        $Elem.val(oComponent.getParamVal("ghost/userdata"));
        
        /** BTicino */  
       	{
                var json = blr.declarations.bticino.functions;
                var targetWho;
                //Parsing BTicino WHOS
                for(var i=0; i<json.length; ++i){
                   	if(json[i].who == 2) { // 2 stands for automatisms
						targetWho=json[i];
						break;
                    }
                }
                if(targetWho!=null) {
                	//populate who dropdown
	               	$dropDown = $componentProperties.find("[eve-manager-id='bticino/who']");
	               	var $option = $("<option></option>");
	               	$option.text(_D(targetWho.label));
                    $option.attr("title", _D(targetWho.label));
                    $option.attr("dictionary", targetWho.label);
                    $option.val(targetWho.who);
                    $option.data("BTicino",targetWho);                    
                    $dropDown.append($option);
                    
                   	var $selected = $dropDown.find("[value='"+ oComponent.getParamVal("bticino/who") +"']").prop("selected",true);
					
					//populate interface dropdown
	               	$dropDown = $componentProperties.find("[eve-manager-id='bticino/interface']");
	                for(var i=0; i<targetWho.interfaces.length; ++i){
	                	
	                    var $option = $("<option></option>");	                   	
                        $option.text(_D(targetWho.interfaces[i].label));
                        $option.attr("title", _D(targetWho.interfaces[i].label));
                        $option.attr("dictionary", targetWho.interfaces[i].label);
                        $option.val(targetWho.interfaces[i].bus);
                        
                        //Append
                        $dropDown.append($option);
	                    
	                }
	                
	                $selected = $dropDown.find("[value='"+ oComponent.getParamVal("bticino/interface") +"']").prop("selected",true);
	               	
	                //populate address dropdown
	               	$dropDown = $componentProperties.find("[eve-manager-id='bticino/address']");
	                for(var i=0; i<targetWho.addresses.length; ++i){
	                	
	                    var $option = $("<option></option>");	                   	
                        $option.text(_D(targetWho.addresses[i].label));
                        $option.attr("title", _D(targetWho.addresses[i].label));
                        $option.attr("dictionary", targetWho.addresses[i].label);
                        $option.val(targetWho.addresses[i].where);
                        
                        //Append
                        $dropDown.append($option);
	                    
	                }
	                
	                $selected = $dropDown.find("[value='"+ oComponent.getParamVal("bticino/address") +"']").prop("selected",true);
	                
	                //populate function dropdown
	               	$dropDown = $componentProperties.find("[eve-manager-id='bticino/function']");
	                for(var i=0; i<targetWho.functions.length; ++i){
	                              
	                    var $option = $("<option></option>");	                   	
                        $option.text(_D(targetWho.functions[i].label));
                        $option.attr("title", _D(targetWho.functions[i].label));
                        $option.attr("dictionary", targetWho.functions[i].label);
                        $option.val(targetWho.functions[i].fid);
                        
                        //Append
                        $dropDown.append($option);   
                                                          
	                }
	                
	                $selected = $dropDown.find("[value='"+ oComponent.getParamVal("bticino/function") +"']").prop("selected",true);
	               	
                }
                			
            }

        function build_modbus_dropdown(strComponentID,jsonArray){
            $drop = $componentProperties.find("[eve-manager-id='" + strComponentID + "']");
            for(var i=0; i<jsonArray.length; ++i){
                var $option = $("<option></option>");
                $option.text(_D(jsonArray[i].label));
                $option.attr("title", _D(jsonArray[i].label));
                $option.attr("dictionary", jsonArray[i].label);
                $option.val(jsonArray[i].value);
                //Append
                $drop.append($option);
            }
            $drop.find("[value='"+ oComponent.getParamVal(strComponentID) +"']").prop("selected",true);
        }

        // Modbus
        {
                var json = blr.declarations.modbus.functions;
                build_modbus_dropdown("modbustcp/open-read-unit-id",json.unit_id);
                build_modbus_dropdown("modbustcp/open-read-function-id",json.read_function_id);
                build_modbus_dropdown("modbustcp/open-read-transform-type",json.switch_transform_type);
                build_modbus_dropdown("modbustcp/open-write-unit-id",json.unit_id);
                build_modbus_dropdown("modbustcp/open-write-function-id",json.write_function_id);
                build_modbus_dropdown("modbustcp/open-write-transform-type",json.switch_transform_type);

                build_modbus_dropdown("modbustcp/stop-read-unit-id",json.unit_id);
                build_modbus_dropdown("modbustcp/stop-read-function-id",json.read_function_id);
                build_modbus_dropdown("modbustcp/stop-read-transform-type",json.switch_transform_type);
                build_modbus_dropdown("modbustcp/stop-write-unit-id",json.unit_id);
                build_modbus_dropdown("modbustcp/stop-write-function-id",json.write_function_id);
                build_modbus_dropdown("modbustcp/stop-write-transform-type",json.switch_transform_type);

                build_modbus_dropdown("modbustcp/close-read-unit-id",json.unit_id);
                build_modbus_dropdown("modbustcp/close-read-function-id",json.read_function_id);
                build_modbus_dropdown("modbustcp/close-read-transform-type",json.switch_transform_type);
                build_modbus_dropdown("modbustcp/close-write-unit-id",json.unit_id);
                build_modbus_dropdown("modbustcp/close-write-function-id",json.write_function_id);
                build_modbus_dropdown("modbustcp/close-write-transform-type",json.switch_transform_type);

            }

        // ModbusTCP Open Read
        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/open-read-unit-id']");
        $Elem.val(oComponent.getParamVal("modbustcp/open-read-unit-id"));
        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/open-read-function-id']");
        $Elem.val(oComponent.getParamVal("modbustcp/open-read-function-id"));
        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/open-read-register-start']");
        $Elem.val(oComponent.getParamVal("modbustcp/open-read-register-start"));
        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/open-read-register-count']");
        $Elem.val(oComponent.getParamVal("modbustcp/open-read-register-count"));
        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/open-read-bit-start']");
        $Elem.val(oComponent.getParamVal("modbustcp/open-read-bit-start"));
        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/open-read-bit-count']");
        $Elem.val(oComponent.getParamVal("modbustcp/open-read-bit-count"));
        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/open-read-transform-type']");
        $Elem.val(oComponent.getParamVal("modbustcp/open-read-transform-type"));
        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/open-read-transform-min']");
        $Elem.val(oComponent.getParamVal("modbustcp/open-read-transform-min"));
        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/open-read-transform-max']");
        $Elem.val(oComponent.getParamVal("modbustcp/open-read-transform-max"));
        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/open-read-transform-multiplier']");
        $Elem.val(oComponent.getParamVal("modbustcp/open-read-transform-multiplier"));

        // ModbusTCP Open Write
        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/open-write-unit-id']");
        $Elem.val(oComponent.getParamVal("modbustcp/open-write-unit-id"));
        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/open-write-function-id']");
        $Elem.val(oComponent.getParamVal("modbustcp/open-write-function-id"));
        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/open-write-register-start']");
        $Elem.val(oComponent.getParamVal("modbustcp/open-write-register-start"));
        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/open-write-register-count']");
        $Elem.val(oComponent.getParamVal("modbustcp/open-write-register-count"));
        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/open-write-bit-start']");
        $Elem.val(oComponent.getParamVal("modbustcp/open-write-bit-start"));
        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/open-write-bit-count']");
        $Elem.val(oComponent.getParamVal("modbustcp/open-write-bit-count"));
        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/open-write-transform-type']");
        $Elem.val(oComponent.getParamVal("modbustcp/open-write-transform-type"));
        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/open-write-transform-min']");
        $Elem.val(oComponent.getParamVal("modbustcp/open-write-transform-min"));
        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/open-write-transform-max']");
        $Elem.val(oComponent.getParamVal("modbustcp/open-write-transform-max"));
        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/open-write-transform-multiplier']");
        $Elem.val(oComponent.getParamVal("modbustcp/open-write-transform-multiplier"));

        // ModbusTCP Stop Read
        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/stop-read-unit-id']");
        $Elem.val(oComponent.getParamVal("modbustcp/stop-read-unit-id"));
        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/stop-read-function-id']");
        $Elem.val(oComponent.getParamVal("modbustcp/stop-read-function-id"));
        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/stop-read-register-start']");
        $Elem.val(oComponent.getParamVal("modbustcp/stop-read-register-start"));
        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/stop-read-register-count']");
        $Elem.val(oComponent.getParamVal("modbustcp/stop-read-register-count"));
        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/stop-read-bit-start']");
        $Elem.val(oComponent.getParamVal("modbustcp/stop-read-bit-start"));
        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/stop-read-bit-count']");
        $Elem.val(oComponent.getParamVal("modbustcp/stop-read-bit-count"));
        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/stop-read-transform-type']");
        $Elem.val(oComponent.getParamVal("modbustcp/stop-read-transform-type"));
        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/stop-read-transform-min']");
        $Elem.val(oComponent.getParamVal("modbustcp/stop-read-transform-min"));
        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/stop-read-transform-max']");
        $Elem.val(oComponent.getParamVal("modbustcp/stop-read-transform-max"));
        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/stop-read-transform-multiplier']");
        $Elem.val(oComponent.getParamVal("modbustcp/stop-read-transform-multiplier"));

        // ModbusTCP Stop Write
        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/stop-write-unit-id']");
        $Elem.val(oComponent.getParamVal("modbustcp/stop-write-unit-id"));
        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/stop-write-function-id']");
        $Elem.val(oComponent.getParamVal("modbustcp/stop-write-function-id"));
        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/stop-write-register-start']");
        $Elem.val(oComponent.getParamVal("modbustcp/stop-write-register-start"));
        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/stop-write-register-count']");
        $Elem.val(oComponent.getParamVal("modbustcp/stop-write-register-count"));
        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/stop-write-bit-start']");
        $Elem.val(oComponent.getParamVal("modbustcp/stop-write-bit-start"));
        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/stop-write-bit-count']");
        $Elem.val(oComponent.getParamVal("modbustcp/stop-write-bit-count"));
        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/stop-write-transform-type']");
        $Elem.val(oComponent.getParamVal("modbustcp/stop-write-transform-type"));
        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/stop-write-transform-min']");
        $Elem.val(oComponent.getParamVal("modbustcp/stop-write-transform-min"));
        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/stop-write-transform-max']");
        $Elem.val(oComponent.getParamVal("modbustcp/stop-write-transform-max"));
        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/stop-write-transform-multiplier']");
        $Elem.val(oComponent.getParamVal("modbustcp/stop-write-transform-multiplier"));

        // ModbusTCP Close Read
        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/close-read-unit-id']");
        $Elem.val(oComponent.getParamVal("modbustcp/close-read-unit-id"));
        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/close-read-function-id']");
        $Elem.val(oComponent.getParamVal("modbustcp/close-read-function-id"));
        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/close-read-register-start']");
        $Elem.val(oComponent.getParamVal("modbustcp/close-read-register-start"));
        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/close-read-register-count']");
        $Elem.val(oComponent.getParamVal("modbustcp/close-read-register-count"));
        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/close-read-bit-start']");
        $Elem.val(oComponent.getParamVal("modbustcp/close-read-bit-start"));
        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/close-read-bit-count']");
        $Elem.val(oComponent.getParamVal("modbustcp/close-read-bit-count"));
        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/close-read-transform-type']");
        $Elem.val(oComponent.getParamVal("modbustcp/close-read-transform-type"));
        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/close-read-transform-min']");
        $Elem.val(oComponent.getParamVal("modbustcp/close-read-transform-min"));
        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/close-read-transform-max']");
        $Elem.val(oComponent.getParamVal("modbustcp/close-read-transform-max"));
        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/close-read-transform-multiplier']");
        $Elem.val(oComponent.getParamVal("modbustcp/close-read-transform-multiplier"));

        // ModbusTCP Close Write
        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/close-write-unit-id']");
        $Elem.val(oComponent.getParamVal("modbustcp/close-write-unit-id"));
        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/close-write-function-id']");
        $Elem.val(oComponent.getParamVal("modbustcp/close-write-function-id"));
        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/close-write-register-start']");
        $Elem.val(oComponent.getParamVal("modbustcp/close-write-register-start"));
        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/close-write-register-count']");
        $Elem.val(oComponent.getParamVal("modbustcp/close-write-register-count"));
        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/close-write-bit-start']");
        $Elem.val(oComponent.getParamVal("modbustcp/close-write-bit-start"));
        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/close-write-bit-count']");
        $Elem.val(oComponent.getParamVal("modbustcp/close-write-bit-count"));
        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/close-write-transform-type']");
        $Elem.val(oComponent.getParamVal("modbustcp/close-write-transform-type"));
        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/close-write-transform-min']");
        $Elem.val(oComponent.getParamVal("modbustcp/close-write-transform-min"));
        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/close-write-transform-max']");
        $Elem.val(oComponent.getParamVal("modbustcp/close-write-transform-max"));
        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/close-write-transform-multiplier']");
        $Elem.val(oComponent.getParamVal("modbustcp/close-write-transform-multiplier"));


        // ModbusRTUTCP Open Read
        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/open-read-unit-id']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/open-read-unit-id"));
        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/open-read-function-id']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/open-read-function-id"));
        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/open-read-register-start']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/open-read-register-start"));
        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/open-read-register-count']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/open-read-register-count"));
        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/open-read-bit-start']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/open-read-bit-start"));
        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/open-read-bit-count']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/open-read-bit-count"));
        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/open-read-transform-type']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/open-read-transform-type"));
        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/open-read-transform-min']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/open-read-transform-min"));
        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/open-read-transform-max']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/open-read-transform-max"));
        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/open-read-transform-multiplier']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/open-read-transform-multiplier"));

        // ModbusRTUTCP Open Write
        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/open-write-unit-id']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/open-write-unit-id"));
        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/open-write-function-id']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/open-write-function-id"));
        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/open-write-register-start']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/open-write-register-start"));
        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/open-write-register-count']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/open-write-register-count"));
        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/open-write-bit-start']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/open-write-bit-start"));
        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/open-write-bit-count']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/open-write-bit-count"));
        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/open-write-transform-type']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/open-write-transform-type"));
        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/open-write-transform-min']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/open-write-transform-min"));
        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/open-write-transform-max']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/open-write-transform-max"));
        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/open-write-transform-multiplier']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/open-write-transform-multiplier"));

        // ModbusRTUTCP Stop Read
        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/stop-read-unit-id']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/stop-read-unit-id"));
        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/stop-read-function-id']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/stop-read-function-id"));
        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/stop-read-register-start']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/stop-read-register-start"));
        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/stop-read-register-count']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/stop-read-register-count"));
        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/stop-read-bit-start']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/stop-read-bit-start"));
        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/stop-read-bit-count']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/stop-read-bit-count"));
        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/stop-read-transform-type']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/stop-read-transform-type"));
        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/stop-read-transform-min']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/stop-read-transform-min"));
        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/stop-read-transform-max']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/stop-read-transform-max"));
        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/stop-read-transform-multiplier']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/stop-read-transform-multiplier"));

        // ModbusRTUTCP Stop Write
        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/stop-write-unit-id']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/stop-write-unit-id"));
        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/stop-write-function-id']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/stop-write-function-id"));
        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/stop-write-register-start']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/stop-write-register-start"));
        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/stop-write-register-count']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/stop-write-register-count"));
        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/stop-write-bit-start']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/stop-write-bit-start"));
        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/stop-write-bit-count']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/stop-write-bit-count"));
        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/stop-write-transform-type']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/stop-write-transform-type"));
        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/stop-write-transform-min']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/stop-write-transform-min"));
        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/stop-write-transform-max']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/stop-write-transform-max"));
        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/stop-write-transform-multiplier']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/stop-write-transform-multiplier"));

        // ModbusRTUTCP Close Read
        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/close-read-unit-id']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/close-read-unit-id"));
        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/close-read-function-id']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/close-read-function-id"));
        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/close-read-register-start']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/close-read-register-start"));
        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/close-read-register-count']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/close-read-register-count"));
        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/close-read-bit-start']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/close-read-bit-start"));
        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/close-read-bit-count']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/close-read-bit-count"));
        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/close-read-transform-type']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/close-read-transform-type"));
        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/close-read-transform-min']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/close-read-transform-min"));
        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/close-read-transform-max']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/close-read-transform-max"));
        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/close-read-transform-multiplier']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/close-read-transform-multiplier"));

        // ModbusRTUTCP Close Write
        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/close-write-unit-id']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/close-write-unit-id"));
        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/close-write-function-id']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/close-write-function-id"));
        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/close-write-register-start']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/close-write-register-start"));
        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/close-write-register-count']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/close-write-register-count"));
        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/close-write-bit-start']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/close-write-bit-start"));
        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/close-write-bit-count']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/close-write-bit-count"));
        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/close-write-transform-type']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/close-write-transform-type"));
        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/close-write-transform-min']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/close-write-transform-min"));
        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/close-write-transform-max']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/close-write-transform-max"));
        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/close-write-transform-multiplier']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/close-write-transform-multiplier"));

    };
}
catch(err){
    console.error(err);
}
