/** Initialize component when component is dragged to component list (onCreateComponent must be exist in each html component file) */
try{
    /** On Define Component Function (Required)
     * Initialize component behavior for virtual scenario composition
     */
    //On define component
    function onDefineComponent(oComponent){
        //console.log("%c/components/"+ oComponent.getType() +"/definition","color:purple");
        
        var oDescriptor = oComponent.getDescriptor();
        var defaultVal = 0;
        
        /*
         * Param 1 -> Type; Param 2 -> Min; Param 3 -> Max;
         */
        oDescriptor.setValueDescription(1,0,100,defaultVal);
        oDescriptor.addDescription(0,_D("Percentage"));
        
        //Set editables
        oDescriptor.setActionEditable(false);
    };
}
catch(err){
    console.error(err);
}
