"use strict";

function IconsManager() {


    var wizard = $("<div id='IconsManagerAddIcons' title='Add icons'></div>");
    wizard.append("<label>Select png icon file</label></br></br>");
    wizard.append("<button id='btn-open-png'>Open ...</button>&nbsp;<span id='pngfile'></span></br></br>");

    wizard.append("</br><label>Icon set name</label></br>");
    wizard.append("<input type='text' id='setname' value='New icon set'/></br>");

    wizard.append("</br><label>Icon width (pixels)</label></br>");
    wizard.append("<input type='text' id='width' value='128'/></br>");
    wizard.append("</br><label>Icons height (pixels)</label></br>");
    wizard.append("<input type='text' id='height' value='128'/></br></br>");

   // wizard.append("<input type='checkbox' id='allprojects' value='false'/>");
   // wizard.append("<label>Use in all next projects</label></br>");




    $("body").append(wizard);

    wizard.find("#btn-open-png").button().click(function (event) {
        var strFile = QT.getOpenFileName("Select PNG icon file", "", "*.png");
        wizard.find("#pngfile").text(strFile);
        event.preventDefault();
    });

    $("body").append(wizard);

    wizard.dialog({
        modal: true,
        width: 650,
        close: function () {
            $(this).remove();
        },
        buttons: {
            "Add this set of icons": function () {
                var filename=$(this).find("#pngfile").text();
                var name=$(this).find("#setname").val();
                var width=$(this).find("#width").val();
                var height=$(this).find("#height").val();
                application.ResoucesManager.addIconsPanFromFile(filename,name,width,height);
                $(this).dialog("close");
                $(this).remove();


            },
            Cancel: function () {
                $(this).dialog("close");
                $(this).remove();
            }
        }
    });

    return wizard;
}

